<?php
/*
  $Id: quantum_iframe.php 1813 2008-01-13 12:53:40Z hpdl $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2008 osCommerce

  Released under the GNU General Public License
  
  http://www.quantumgateway.com

  by

  Andres Roca - CDG Commerce
  andresr@cdgcommerce.com
*/


function _quantumilf_http_post($host, $path, $data, $port = 80) {

        $req = _quantumilf_qsencode ($data);
		$response = '';
		if( false == ( $fs = fsockopen("ssl://secure.quantumgateway.com", 443, $errno, $errstr, 30))) {
			die('Could not open socket');
		} else {

			$http_request  = "POST $path HTTP/1.0\r\n";
			$http_request .= "Host: $host\r\n";
			$http_request .= "Content-Type: application/x-www-form-urlencoded;\r\n";
			$http_request .= "Content-Length: " . strlen($req) . "\r\n";
			$agent = "Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.4) Gecko/20030624 Netscape/7.1 (affgrabber)";
			$http_request .= "User-Agent: $agent\r\n";
			$http_request .= "\r\n";
			$http_request .= $req;
 
		    fwrite($fs, $http_request);
			while (!feof($fs)) {
				$response .= fgets($fs, 1160); // One TCP-IP packet
			}
			
    		fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		}

        return $response;
}

function _quantumilf_qsencode ($data) {
        $req = "";
        foreach ( $data as $key => $value )
                $req .= $key . '=' . urlencode( stripslashes($value) ) . '&';

        // Cut the last '&'
        $req=substr($req,0,strlen($req)-1);
        return $req;
}


function quantumilf_getCode($API_Username, $API_Key, $width, $height, $amount='0', $id='0', $custid='0', $method='0', $addtoVault='N', $skipshipping='N', $post_return_url_approved, $post_return_url_declined, $first_name='', $last_name='', $address='', $city='', $state='', $zip='', $email='') {
	$thereturn = array();
	$random = rand(1111111111, 9999999999);
	$random = (int)$random;
	$response = _quantumilf_http_post("secure.quantumgateway.com", "/cgi/ilf_authenticate.php",
                                          array (
                                                 'API_Username' => $API_Username,
                                                 'API_Key' => $API_Key,
                                                 'randval' => $random,
												 'lastip' => $_SERVER['REMOTE_ADDR']
                                                 ), 443
                                          );
	if (is_array($response)) {
		if ($response[1] != 'error') {
			$extrapars = '';
			if ($method != '0') {
				$extrapars .= "&METHOD=$method";	
			}
			if ($addtoVault != 'N') {
				$extrapars .= "&AddToVault=$addtoVault";				
			}
			if ($addtoVault != 'N') {
				$extrapars .= "&skip_shipping_info=$skipshipping";				
			}
			if ($custid != '0') {
				$extrapars .= "&CustomerID=" . urlencode($custid);				
			}
			if ($amount != '0')	{
				$extrapars .= "&Amount=$amount";
			}
			if ($id != '0')	{
				$extrapars .= "&ID=" . urlencode($id);
			}
			if(empty($first_name)) {} else {
				$extrapars .= "&FNAME=" . urlencode($first_name);
			}
			if(empty($last_name)) {} else {
				$extrapars .= "&LNAME=" . urlencode($last_name);
			}
			if(empty($address)) {} else {
				$extrapars .= "&BADDR1=" . urlencode($address);
			}
			if(empty($city)) {} else {
				$extrapars .= "&BCITT=" . urlencode($city);
			}
			if(empty($state)) {} else {
				$extrapars .= "&BSTATE=" . urlencode($state);
			}
			if(empty($zip)) {} else {
				$extrapars .= "&BZIP1=" . urlencode($zip);
			}
			if(empty($email)) {} else {
				$extrapars .= "&BCUST_EMAIL=" . urlencode($email);
			}
			
$extrapars .= "&override_email_customer=N";// dont send gateway receipt to customer	
$extrapars .= "&override_trans_email=N";// dont send gateway receipt to merchant

			
			$extrapars .= "&skip_shipping_info=Y&post_return_url_approved=" . $post_return_url_approved . "&post_return_url_declined=" . $post_return_url_declined; 
			
			$thereturn['iframe'] = '<iframe src="https://secure.quantumgateway.com/cgi/ilf.php?k=' . $response[1] . '&ip=' . $_SERVER['REMOTE_ADDR'] . $extrapars . '" height="' . $height . '" width="' . $width . '" frameborder="0"></iframe><br/>';	
			$thereturn['script']  = '<script src="https://secure.quantumgateway.com/javascript/prototype.js" type="text/javascript"></script>
<script type="text/javascript">
function refreshSession(thek, theip) {
	var randomnumber=Math.random();
	var tposturl = "quantum_iframe.php?cachebuster=" + randomnumber;
	var thequerystring = "ajax=true&ip=" + theip + "&k=" + thek;
	var thecheck = new Ajax.Request(tposturl, {	method: "post", parameters: thequerystring });
	
}
setInterval("refreshSession(\'' . $response[1] . '\',\'' . $_SERVER['REMOTE_ADDR'] . '\')",20000);
</script>
';
		}
	}
	return $thereturn;
}
if (isset($_POST['ajax']))  {
	if ($_POST['ajax'] == "true") {
	$response = _quantumilf_http_post("secure.quantumgateway.com", "/cgi/ilf_refresh.php",
									  array (
											 'ip' => $_POST['ip'],
											 'k' => $_POST['k']
											 ), 443
									  );
	}	
}
?>